import React from 'react';
import ReactDom from 'react-dom';
import { loadApp } from './utils';

class Bootstrap extends React.PureComponent <any, any> {
    App: any;
    currentBundle: string = '';

    async downloader(bundleName: string) {
        let _bundleName = bundleName;
        this.currentBundle = bundleName;
        this.App = await loadApp(_bundleName);
        this.forceUpdate();
    }

    mountApp = async(nameApp) => {
       await this.downloader(nameApp);
       this.App.mount(this.App.default)
    }

    unmountApp = () => {
        this.App.unmount();
    }

    render () {
        return (
            <div>
                <button onClick={() => this.mountApp('pl')}>
                    загрузить приложение news
                </button>
                <button onClick={() => this.mountApp('uds-sections')}>
                    загрузить приложение uds-sections
                </button>
                <button onClick={() => this.mountApp('orgApp')}>
                    загрузить приложение org
                </button>
                <button onClick={() => this.unmountApp()}>
                    выгрузить приложение 2
                </button>
            </div>
        );
    }
}

ReactDom.render(
    <Bootstrap/>,
    document.getElementById('bootstrap')
);


